package com.ccpp.pgw.android.demo.merchant.helper;

import android.util.Log;

import com.ccpp.pgw.android.demo.merchant.utils.Base64;
import com.ccpp.pgw.sdk.android.model.Constants;

import org.json.JSONObject;

/**
 * Created by DavidBilly PK on 27/9/18.
 */
public class StringHelper {

    private final String TAG = StringHelper.class.getName();

    public byte[] base64Decode(final String input) {
        return Base64.getDecoder().decode(input);
    }

    public String base64Encode(final byte[] input) {
        return Base64.getEncoder().encodeToString(input).replace("\n", "");
    }

    public String extractPaymentToken(String response) {

        String decodedResponse = "";

        try {
            decodedResponse = new String(android.util.Base64.decode(response, android.util.Base64.DEFAULT));
        } catch (Exception e) {
            Log.e(TAG, "Payment Token Base64 decode error!");
        }

        String paymentToken = "";

        try {
            JSONObject jsonObject = new JSONObject(decodedResponse);
            paymentToken = jsonObject.optString(Constants.JSON_NAME_PAYMENT_TOKEN);
        } catch (Exception e) {
            Log.e(TAG, "Payment Token JSON error!");
        }

        if(paymentToken.isEmpty()) {
            Log.d(TAG, "Payment Token not found! JSON: " + decodedResponse);
        }

        return paymentToken;
    }
}
